Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/tesselation.cpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -48,5 +48,5 @@
   //Log() << Verbose(5) << "Erasing point nr. " << Nr << "." << endl;
   if (!lines.empty())
-    eLog() << Verbose(0) << "WARNING: Memory Leak! I " << *this << " am still connected to some lines." << endl;
+    eLog() << Verbose(2) << "Memory Leak! I " << *this << " am still connected to some lines." << endl;
   node = NULL;
 };
@@ -153,5 +153,5 @@
   }
   if (!triangles.empty())
-    eLog() << Verbose(0) << "WARNING: Memory Leak! I " << *this << " am still connected to some triangles." << endl;
+    eLog() << Verbose(2) << "Memory Leak! I " << *this << " am still connected to some triangles." << endl;
 };
 
@@ -188,5 +188,5 @@
   // get the two triangles
   if (triangles.size() != 2) {
-    Log() << Verbose(1) << "ERROR: Baseline " << *this << " is connected to less than two triangles, Tesselation incomplete!" << endl;
+    eLog() << Verbose(1) << "Baseline " << *this << " is connected to less than two triangles, Tesselation incomplete!" << endl;
     return true;
   }
@@ -226,5 +226,5 @@
       i++;
     } else {
-      //Log() << Verbose(2) << "ERROR: I cannot find third node in triangle, something's wrong." << endl;
+      //eLog() << Verbose(1) << "I cannot find third node in triangle, something's wrong." << endl;
       return true;
     }
@@ -333,7 +333,6 @@
   if (Counter < 3)
     {
-      eLog() << Verbose(0) << "ERROR! We have a triangle with only two distinct endpoints!"
-          << endl;
-      //exit(1);
+      eLog() << Verbose(0) << "ERROR! We have a triangle with only two distinct endpoints!" << endl;
+      performCriticalExit();
     }
   Log() << Verbose(0) << "." << endl;
@@ -409,5 +408,5 @@
   } while (CrossPoint.NormSquared() < MYEPSILON);
   if (i==3) {
-    Log() << Verbose(1) << "ERROR: Could not find any cross points, something's utterly wrong here!" << endl;
+    eLog() << Verbose(1) << "Could not find any cross points, something's utterly wrong here!" << endl;
     exit(255);
   }
@@ -634,5 +633,5 @@
       runner->second = NULL;
     } else
-      eLog() << Verbose(1) << "ERROR: The triangle " << runner->first << " has already been free'd." << endl;
+      eLog() << Verbose(1) << "The triangle " << runner->first << " has already been free'd." << endl;
   }
   Log() << Verbose(1) << "This envelope was written to file " << TriangleFilesWritten << " times(s)." << endl;
@@ -1174,5 +1173,5 @@
             if (NewLines[j]->IsConnectedTo(BLS[0])) {
               if (n>2) {
-                Log() << Verbose(1) << "ERROR: " << BLS[0] << " connects to all of the new lines?!" << endl;
+                Log() << Verbose(1) << BLS[0] << " connects to all of the new lines?!" << endl;
                 return false;
               } else
@@ -1191,5 +1190,5 @@
       }
     } else { // something is wrong with FindClosestTriangleToPoint!
-      Log() << Verbose(1) << "ERROR: The closest triangle did not produce an intersection!" << endl;
+      eLog() << Verbose(1) << "The closest triangle did not produce an intersection!" << endl;
       return false;
     }
@@ -1243,4 +1242,18 @@
 }
 ;
+
+/** Sets point to a present Tesselation::PointsOnBoundary.
+ * Tesselation::TPS is set to the existing one or NULL if not found.
+ * @param Candidate point to set to
+ * @param n index for this point in Tesselation::TPS array
+ */
+void Tesselation::SetTesselationPoint(TesselPoint* Candidate, const int n) const
+{
+  PointMap::const_iterator FindPoint = PointsOnBoundary.find(Candidate->nr);
+  if (FindPoint != PointsOnBoundary.end())
+    TPS[n] = FindPoint->second;
+  else
+    TPS[n] = NULL;
+};
 
 /** Function tries to add line from current Points in BPS to BoundaryLineSet.
@@ -1365,5 +1378,5 @@
       triangle->lines[i] = NULL;  // free'd or not: disconnect
     } else
-      eLog() << Verbose(0) << "ERROR: This line " << i << " has already been free'd." << endl;
+      eLog() << Verbose(1) << "This line " << i << " has already been free'd." << endl;
   }
 
@@ -1418,8 +1431,8 @@
       line->endpoints[i] = NULL;  // free'd or not: disconnect
     } else
-      eLog() << Verbose(0) << "ERROR: Endpoint " << i << " has already been free'd." << endl;
+      eLog() << Verbose(1) << "Endpoint " << i << " has already been free'd." << endl;
   }
   if (!line->triangles.empty())
-    eLog() << Verbose(0) << "WARNING: Memory Leak! I " << *line << " am still connected to some triangles." << endl;
+    eLog() << Verbose(2) << "Memory Leak! I " << *line << " am still connected to some triangles." << endl;
 
   if (LinesOnBoundary.erase(line->Nr))
@@ -1451,5 +1464,6 @@
  *                 triangles exist which is the maximum for three points
  */
-int Tesselation::CheckPresenceOfTriangle(TesselPoint *Candidates[3]) {
+int Tesselation::CheckPresenceOfTriangle(TesselPoint *Candidates[3]) const
+{
   int adjacentTriangleCount = 0;
   class BoundaryPointSet *Points[3];
@@ -1458,5 +1472,5 @@
   // builds a triangle point set (Points) of the end points
   for (int i = 0; i < 3; i++) {
-    PointMap::iterator FindPoint = PointsOnBoundary.find(Candidates[i]->nr);
+    PointMap::const_iterator FindPoint = PointsOnBoundary.find(Candidates[i]->nr);
     if (FindPoint != PointsOnBoundary.end()) {
       Points[i] = FindPoint->second;
@@ -1471,9 +1485,9 @@
       for (int j = i; j < 3; j++) {
         if (Points[j] != NULL) {
-          LineMap::iterator FindLine = Points[i]->lines.find(Points[j]->node->nr);
+          LineMap::const_iterator FindLine = Points[i]->lines.find(Points[j]->node->nr);
           for (; (FindLine != Points[i]->lines.end()) && (FindLine->first == Points[j]->node->nr); FindLine++) {
             TriangleMap *triangles = &FindLine->second->triangles;
             Log() << Verbose(3) << "Current line is " << FindLine->first << ": " << *(FindLine->second) << " with triangles " << triangles << "." << endl;
-            for (TriangleMap::iterator FindTriangle = triangles->begin(); FindTriangle != triangles->end(); FindTriangle++) {
+            for (TriangleMap::const_iterator FindTriangle = triangles->begin(); FindTriangle != triangles->end(); FindTriangle++) {
               if (FindTriangle->second->IsPresentTupel(Points)) {
                 adjacentTriangleCount++;
@@ -1589,5 +1603,5 @@
           }
         } else {
-          eLog() << Verbose(0) << "ERROR: The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << " is invalid!" << endl;
+          eLog() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << "," << LC->n[2] << " is invalid!" << endl;
         }
       }
@@ -1700,4 +1714,147 @@
 };
 
+/** Checks for a given baseline and a third point candidate whether baselines of the found triangle don't have even better candidates.
+ * This is supposed to prevent early closing of the tesselation.
+ * \param *BaseRay baseline, i.e. not \a *OptCandidate
+ * \param *ThirdNode third point in triangle, not in BoundaryLineSet::endpoints
+ * \param ShortestAngle path length on this circle band for the current \a *ThirdNode
+ * \param RADIUS radius of sphere
+ * \param *LC LinkedCell structure
+ * \return true - there is a better candidate (smaller angle than \a ShortestAngle), false - no better TesselPoint candidate found
+ */
+bool Tesselation::HasOtherBaselineBetterCandidate(const BoundaryLineSet * const BaseRay, const TesselPoint * const ThirdNode, double ShortestAngle, double RADIUS, const LinkedCell * const LC) const
+{
+  bool result = false;
+  Vector CircleCenter;
+  Vector CirclePlaneNormal;
+  Vector OldSphereCenter;
+  Vector SearchDirection;
+  Vector helper;
+  TesselPoint *OtherOptCandidate = NULL;
+  double OtherShortestAngle = 2.*M_PI; // This will indicate the quadrant.
+  double radius, CircleRadius;
+  BoundaryLineSet *Line = NULL;
+  BoundaryTriangleSet *T = NULL;
+
+  Log() << Verbose(1) << "Begin of HasOtherBaselineBetterCandidate" << endl;
+
+  // check both other lines
+  PointMap::const_iterator FindPoint = PointsOnBoundary.find(ThirdNode->nr);
+  if (FindPoint != PointsOnBoundary.end()) {
+    for (int i=0;i<2;i++) {
+      LineMap::const_iterator FindLine = (FindPoint->second)->lines.find(BaseRay->endpoints[0]->node->nr);
+      if (FindLine != (FindPoint->second)->lines.end()) {
+        Line = FindLine->second;
+        Log() << Verbose(1) << "Found line " << *Line << "." << endl;
+        if (Line->triangles.size() == 1) {
+          T = Line->triangles.begin()->second;
+          // construct center of circle
+          CircleCenter.CopyVector(Line->endpoints[0]->node->node);
+          CircleCenter.AddVector(Line->endpoints[1]->node->node);
+          CircleCenter.Scale(0.5);
+
+          // construct normal vector of circle
+          CirclePlaneNormal.CopyVector(Line->endpoints[0]->node->node);
+          CirclePlaneNormal.SubtractVector(Line->endpoints[1]->node->node);
+
+          // calculate squared radius of circle
+          radius = CirclePlaneNormal.ScalarProduct(&CirclePlaneNormal);
+          if (radius/4. < RADIUS*RADIUS) {
+            CircleRadius = RADIUS*RADIUS - radius/4.;
+            CirclePlaneNormal.Normalize();
+            //Log() << Verbose(2) << "INFO: CircleCenter is at " << CircleCenter << ", CirclePlaneNormal is " << CirclePlaneNormal << " with circle radius " << sqrt(CircleRadius) << "." << endl;
+
+            // construct old center
+            GetCenterofCircumcircle(&OldSphereCenter, *T->endpoints[0]->node->node, *T->endpoints[1]->node->node, *T->endpoints[2]->node->node);
+            helper.CopyVector(&T->NormalVector);  // normal vector ensures that this is correct center of the two possible ones
+            radius = Line->endpoints[0]->node->node->DistanceSquared(&OldSphereCenter);
+            helper.Scale(sqrt(RADIUS*RADIUS - radius));
+            OldSphereCenter.AddVector(&helper);
+            OldSphereCenter.SubtractVector(&CircleCenter);
+            //Log() << Verbose(2) << "INFO: OldSphereCenter is at " << OldSphereCenter << "." << endl;
+
+            // construct SearchDirection
+            SearchDirection.MakeNormalVector(&T->NormalVector, &CirclePlaneNormal);
+            helper.CopyVector(Line->endpoints[0]->node->node);
+            helper.SubtractVector(ThirdNode->node);
+            if (helper.ScalarProduct(&SearchDirection) < -HULLEPSILON)// ohoh, SearchDirection points inwards!
+              SearchDirection.Scale(-1.);
+            SearchDirection.ProjectOntoPlane(&OldSphereCenter);
+            SearchDirection.Normalize();
+            Log() << Verbose(2) << "INFO: SearchDirection is " << SearchDirection << "." << endl;
+            if (fabs(OldSphereCenter.ScalarProduct(&SearchDirection)) > HULLEPSILON) {
+              // rotated the wrong way!
+              eLog() << Verbose(1) << "SearchDirection and RelativeOldSphereCenter are still not orthogonal!" << endl;
+            }
+
+            // add third point
+            CandidateList *OptCandidates = new CandidateList();
+            FindThirdPointForTesselation(T->NormalVector, SearchDirection, OldSphereCenter, Line, ThirdNode, OptCandidates, &OtherShortestAngle, RADIUS, LC);
+            for (CandidateList::iterator it = OptCandidates->begin(); it != OptCandidates->end(); ++it) {
+              if (((*it)->point == BaseRay->endpoints[0]->node) || ((*it)->point == BaseRay->endpoints[1]->node)) // skip if it's the same triangle than suggested
+                continue;
+              Log() << Verbose(1) << " Third point candidate is " << *(*it)->point
+              << " with circumsphere's center at " << (*it)->OptCenter << "." << endl;
+              Log() << Verbose(1) << " Baseline is " << *BaseRay << endl;
+
+              // check whether all edges of the new triangle still have space for one more triangle (i.e. TriangleCount <2)
+              TesselPoint *PointCandidates[3];
+              PointCandidates[0] = (*it)->point;
+              PointCandidates[1] = BaseRay->endpoints[0]->node;
+              PointCandidates[2] = BaseRay->endpoints[1]->node;
+              bool check=false;
+              int existentTrianglesCount = CheckPresenceOfTriangle(PointCandidates);
+              // If there is no triangle, add it regularly.
+              if (existentTrianglesCount == 0) {
+                SetTesselationPoint((*it)->point, 0);
+                SetTesselationPoint(BaseRay->endpoints[0]->node, 1);
+                SetTesselationPoint(BaseRay->endpoints[1]->node, 2);
+
+                if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const )TPS)) {
+                  OtherOptCandidate = (*it)->point;
+                  check = true;
+                }
+              } else if ((existentTrianglesCount >= 1) && (existentTrianglesCount <= 3)) { // If there is a planar region within the structure, we need this triangle a second time.
+                SetTesselationPoint((*it)->point, 0);
+                SetTesselationPoint(BaseRay->endpoints[0]->node, 1);
+                SetTesselationPoint(BaseRay->endpoints[1]->node, 2);
+
+                // We demand that at most one new degenerate line is created and that this line also already exists (which has to be the case due to existentTrianglesCount == 1)
+                // i.e. at least one of the three lines must be present with TriangleCount <= 1
+                if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const)TPS)) {
+                  OtherOptCandidate = (*it)->point;
+                  check = true;
+                }
+              }
+
+              if (check) {
+                if (ShortestAngle > OtherShortestAngle) {
+                  Log() << Verbose(1) << "There is a better candidate than " << *ThirdNode << " with " << ShortestAngle << " from baseline " << *Line << ": " << *OtherOptCandidate << " with " << OtherShortestAngle << "." << endl;
+                  result = true;
+                  break;
+                }
+              }
+            }
+            delete(OptCandidates);
+            if (result)
+              break;
+          } else {
+            Log() << Verbose(1) << "Circumcircle for base line " << *Line << " and base triangle " << T << " is too big!" << endl;
+          }
+        } else {
+          eLog() << Verbose(2) << "Baseline is connected to two triangles already?" << endl;
+        }
+      } else {
+        Log() << Verbose(2) << "No present baseline between " << BaseRay->endpoints[0] << " and candidate " << *ThirdNode << "." << endl;
+      }
+    }
+  } else {
+    eLog() << Verbose(1) << "Could not find the TesselPoint " << *ThirdNode << "." << endl;
+  }
+
+  Log() << Verbose(1) << "End of HasOtherBaselineBetterCandidate" << endl;
+
+  return result;
+};
 
 /** This function finds a triangle to a line, adjacent to an existing one.
@@ -1766,5 +1923,5 @@
     if (fabs(OldSphereCenter.ScalarProduct(&SearchDirection)) > HULLEPSILON) {
       // rotated the wrong way!
-      eLog() << Verbose(0) << "ERROR: SearchDirection and RelativeOldSphereCenter are still not orthogonal!" << endl;
+      eLog() << Verbose(1) << "SearchDirection and RelativeOldSphereCenter are still not orthogonal!" << endl;
     }
 
@@ -1777,12 +1934,11 @@
 
   if (OptCandidates->begin() == OptCandidates->end()) {
-    eLog() << Verbose(0) << "WARNING: Could not find a suitable candidate." << endl;
+    eLog() << Verbose(2) << "Could not find a suitable candidate." << endl;
     return false;
   }
   Log() << Verbose(1) << "Third Points are ";
   for (CandidateList::iterator it = OptCandidates->begin(); it != OptCandidates->end(); ++it) {
-    Log() << Verbose(0) << " " << *(*it)->point;
-  }
-  Log() << Verbose(0) << endl;
+    Log() << Verbose(1) << " " << *(*it)->point << endl;
+  }
 
   BoundaryLineSet *BaseRay = &Line;
@@ -1800,40 +1956,17 @@
 
     BTS = NULL;
-    // If there is no triangle, add it regularly.
-    if (existentTrianglesCount == 0) {
-      AddTesselationPoint((*it)->point, 0);
-      AddTesselationPoint(BaseRay->endpoints[0]->node, 1);
-      AddTesselationPoint(BaseRay->endpoints[1]->node, 2);
-
-      if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const )TPS)) {
-        AddTesselationLine(TPS[0], TPS[1], 0);
-        AddTesselationLine(TPS[0], TPS[2], 1);
-        AddTesselationLine(TPS[1], TPS[2], 2);
-
-        BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
-        AddTesselationTriangle();
-        (*it)->OptCenter.Scale(-1.);
-        BTS->GetNormalVector((*it)->OptCenter);
-        (*it)->OptCenter.Scale(-1.);
-
-        Log() << Verbose(0) << "--> New triangle with " << *BTS << " and normal vector " << BTS->NormalVector
-          << " for this triangle ... " << endl;
-      //Log() << Verbose(1) << "We have "<< TrianglesOnBoundaryCount << " for line " << *BaseRay << "." << endl;
-      } else {
-        Log() << Verbose(1) << "WARNING: This triangle consisting of ";
-        Log() << Verbose(0) << *(*it)->point << ", ";
-        Log() << Verbose(0) << *BaseRay->endpoints[0]->node << " and ";
-        Log() << Verbose(0) << *BaseRay->endpoints[1]->node << " ";
-        Log() << Verbose(0) << "exists and is not added, as it does not seem helpful!" << endl;
-        result = false;
-      }
-    } else if ((existentTrianglesCount >= 1) && (existentTrianglesCount <= 3)) { // If there is a planar region within the structure, we need this triangle a second time.
+    // check for present edges and whether we reach better candidates from them
+    //if (HasOtherBaselineBetterCandidate(BaseRay, (*it)->point, ShortestAngle, RADIUS, LC) ) {
+    if (0) {
+      result = false;
+      break;
+    } else {
+      // If there is no triangle, add it regularly.
+      if (existentTrianglesCount == 0) {
         AddTesselationPoint((*it)->point, 0);
         AddTesselationPoint(BaseRay->endpoints[0]->node, 1);
         AddTesselationPoint(BaseRay->endpoints[1]->node, 2);
 
-        // We demand that at most one new degenerate line is created and that this line also already exists (which has to be the case due to existentTrianglesCount == 1)
-        // i.e. at least one of the three lines must be present with TriangleCount <= 1
-        if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const)TPS)) {
+        if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const )TPS)) {
           AddTesselationLine(TPS[0], TPS[1], 0);
           AddTesselationLine(TPS[0], TPS[2], 1);
@@ -1841,15 +1974,14 @@
 
           BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
-          AddTesselationTriangle();  // add to global map
-
-          (*it)->OtherOptCenter.Scale(-1.);
-          BTS->GetNormalVector((*it)->OtherOptCenter);
-          (*it)->OtherOptCenter.Scale(-1.);
-
-          Log() << Verbose(0) << "--> WARNING: Special new triangle with " << *BTS << " and normal vector " << BTS->NormalVector
-          << " for this triangle ... " << endl;
-          Log() << Verbose(1) << "We have "<< BaseRay->triangles.size() << " for line " << BaseRay << "." << endl;
+          AddTesselationTriangle();
+          (*it)->OptCenter.Scale(-1.);
+          BTS->GetNormalVector((*it)->OptCenter);
+          (*it)->OptCenter.Scale(-1.);
+
+          Log() << Verbose(0) << "--> New triangle with " << *BTS << " and normal vector " << BTS->NormalVector
+            << " for this triangle ... " << endl;
+        //Log() << Verbose(1) << "We have "<< TrianglesOnBoundaryCount << " for line " << *BaseRay << "." << endl;
         } else {
-          Log() << Verbose(1) << "WARNING: This triangle consisting of ";
+          eLog() << Verbose(2) << "This triangle consisting of ";
           Log() << Verbose(0) << *(*it)->point << ", ";
           Log() << Verbose(0) << *BaseRay->endpoints[0]->node << " and ";
@@ -1858,11 +1990,37 @@
           result = false;
         }
-    } else {
-      Log() << Verbose(1) << "This triangle consisting of ";
-      Log() << Verbose(0) << *(*it)->point << ", ";
-      Log() << Verbose(0) << *BaseRay->endpoints[0]->node << " and ";
-      Log() << Verbose(0) << *BaseRay->endpoints[1]->node << " ";
-      Log() << Verbose(0) << "is invalid!" << endl;
-      result = false;
+      } else if ((existentTrianglesCount >= 1) && (existentTrianglesCount <= 3)) { // If there is a planar region within the structure, we need this triangle a second time.
+          AddTesselationPoint((*it)->point, 0);
+          AddTesselationPoint(BaseRay->endpoints[0]->node, 1);
+          AddTesselationPoint(BaseRay->endpoints[1]->node, 2);
+
+          // We demand that at most one new degenerate line is created and that this line also already exists (which has to be the case due to existentTrianglesCount == 1)
+          // i.e. at least one of the three lines must be present with TriangleCount <= 1
+          if (CheckLineCriteriaForDegeneratedTriangle((const BoundaryPointSet ** const)TPS)) {
+            AddTesselationLine(TPS[0], TPS[1], 0);
+            AddTesselationLine(TPS[0], TPS[2], 1);
+            AddTesselationLine(TPS[1], TPS[2], 2);
+
+            BTS = new class BoundaryTriangleSet(BLS, TrianglesOnBoundaryCount);
+            AddTesselationTriangle();  // add to global map
+
+            (*it)->OtherOptCenter.Scale(-1.);
+            BTS->GetNormalVector((*it)->OtherOptCenter);
+            (*it)->OtherOptCenter.Scale(-1.);
+
+            eLog() << Verbose(2) << "--> WARNING: Special new triangle with " << *BTS << " and normal vector " << BTS->NormalVector << " for this triangle ... " << endl;
+            Log() << Verbose(1) << "We have "<< BaseRay->triangles.size() << " for line " << BaseRay << "." << endl;
+          } else {
+            eLog() << Verbose(2) << "This triangle consisting of " << *(*it)->point << ", " << *BaseRay->endpoints[0]->node << " and " << *BaseRay->endpoints[1]->node << " " << "exists and is not added, as it does not seem helpful!" << endl;
+            result = false;
+          }
+      } else {
+        Log() << Verbose(1) << "This triangle consisting of ";
+        Log() << Verbose(0) << *(*it)->point << ", ";
+        Log() << Verbose(0) << *BaseRay->endpoints[0]->node << " and ";
+        Log() << Verbose(0) << *BaseRay->endpoints[1]->node << " ";
+        Log() << Verbose(0) << "is invalid!" << endl;
+        result = false;
+      }
     }
 
@@ -1870,5 +2028,5 @@
     BaseRay = BLS[0];
     if ((BTS != NULL) && (BTS->NormalVector.NormSquared() < MYEPSILON)) {
-      Log() << Verbose(1) << "CRITICAL: Triangle " << *BTS << " has zero normal vector!" << endl;
+      eLog() << Verbose(1) << "Triangle " << *BTS << " has zero normal vector!" << endl;
       exit(255);
     }
@@ -2011,5 +2169,5 @@
     BaseLineNormal.Zero();
     if (Base->triangles.size() < 2) {
-      Log() << Verbose(2) << "ERROR: Less than two triangles are attached to this baseline!" << endl;
+      eLog() << Verbose(1) << "Less than two triangles are attached to this baseline!" << endl;
       return 0.;
     }
@@ -2051,5 +2209,5 @@
   BaseLineNormal.Zero();
   if (Base->triangles.size() < 2) {
-    Log() << Verbose(2) << "ERROR: Less than two triangles are attached to this baseline!" << endl;
+    eLog() << Verbose(1) << "Less than two triangles are attached to this baseline!" << endl;
     return NULL;
   }
@@ -2087,15 +2245,15 @@
   // check whether everything is in place to create new lines and triangles
   if (i<4) {
-    Log() << Verbose(1) << "ERROR: We have not gathered enough baselines!" << endl;
+    eLog() << Verbose(1) << "We have not gathered enough baselines!" << endl;
     return NULL;
   }
   for (int j=0;j<4;j++)
     if (OldLines[j] == NULL) {
-      Log() << Verbose(1) << "ERROR: We have not gathered enough baselines!" << endl;
+      eLog() << Verbose(1) << "We have not gathered enough baselines!" << endl;
       return NULL;
     }
   for (int j=0;j<2;j++)
     if (OldPoints[j] == NULL) {
-      Log() << Verbose(1) << "ERROR: We have not gathered enough endpoints!" << endl;
+      eLog() << Verbose(1) << "We have not gathered enough endpoints!" << endl;
       return NULL;
     }
@@ -2173,20 +2331,14 @@
       N[i] = LC->n[i];
   } else {
-    eLog() << Verbose(0) << "ERROR: Point " << *a << " is not found in cell " << LC->index << "." << endl;
+    eLog() << Verbose(1) << "Point " << *a << " is not found in cell " << LC->index << "." << endl;
     return;
   }
   // then go through the current and all neighbouring cells and check the contained points for possible candidates
-  Log() << Verbose(3) << "LC Intervals from [";
-  for (int i=0;i<NDIM;i++) {
-  Log() << Verbose(0) << " " << N[i] << "<->" << LC->N[i];
-  }
-  Log() << Verbose(0) << "] :";
   for (int i=0;i<NDIM;i++) {
     Nlower[i] = ((N[i]-1) >= 0) ? N[i]-1 : 0;
     Nupper[i] = ((N[i]+1) < LC->N[i]) ? N[i]+1 : LC->N[i]-1;
-    Log() << Verbose(0) << " [" << Nlower[i] << "," << Nupper[i] << "] ";
-  }
-  Log() << Verbose(0) << endl;
-
+  }
+  Log() << Verbose(3) << "LC Intervals from [" << N[0] << "<->" << LC->N[0] << ", " << N[1] << "<->" << LC->N[1] << ", " << N[2] << "<->" << LC->N[2] << "] :"
+    << " [" << Nlower[0] << "," << Nupper[0] << "], " << " [" << Nlower[1] << "," << Nupper[1] << "], " << " [" << Nlower[2] << "," << Nupper[2] << "], " << endl;
 
   for (LC->n[0] = Nlower[0]; LC->n[0] <= Nupper[0]; LC->n[0]++)
@@ -2280,5 +2432,5 @@
  * @param *LC LinkedCell structure with neighbouring points
  */
-void Tesselation::FindThirdPointForTesselation(Vector NormalVector, Vector SearchDirection, Vector OldSphereCenter, class BoundaryLineSet *BaseLine, class TesselPoint  *ThirdNode, CandidateList* &candidates, double *ShortestAngle, const double RADIUS, const LinkedCell *LC)
+void Tesselation::FindThirdPointForTesselation(Vector &NormalVector, Vector &SearchDirection, Vector &OldSphereCenter, class BoundaryLineSet *BaseLine, const class TesselPoint  * const ThirdNode, CandidateList* &candidates, double *ShortestAngle, const double RADIUS, const LinkedCell *LC) const
 {
   Vector CircleCenter;  // center of the circle, i.e. of the band of sphere's centers
@@ -2318,5 +2470,5 @@
     // test whether old center is on the band's plane
     if (fabs(OldSphereCenter.ScalarProduct(&CirclePlaneNormal)) > HULLEPSILON) {
-      eLog() << Verbose(0) << "ERROR: Something's very wrong here: OldSphereCenter is not on the band's plane as desired by " << fabs(OldSphereCenter.ScalarProduct(&CirclePlaneNormal)) << "!" << endl;
+      eLog() << Verbose(1) << "Something's very wrong here: OldSphereCenter is not on the band's plane as desired by " << fabs(OldSphereCenter.ScalarProduct(&CirclePlaneNormal)) << "!" << endl;
       OldSphereCenter.ProjectOntoPlane(&CirclePlaneNormal);
     }
@@ -2328,5 +2480,5 @@
       //Log() << Verbose(2) << "INFO: SearchDirection is " << SearchDirection << "." << endl;
       if (fabs(OldSphereCenter.ScalarProduct(&SearchDirection)) > HULLEPSILON) {  // rotated the wrong way!
-        eLog() << Verbose(0) << "ERROR: SearchDirection and RelativeOldSphereCenter are not orthogonal!" << endl;
+        eLog() << Verbose(1) << "SearchDirection and RelativeOldSphereCenter are not orthogonal!" << endl;
       }
 
@@ -2337,5 +2489,5 @@
         //Log() << Verbose(2) << "INFO: Center cell is " << N[0] << ", " << N[1] << ", " << N[2] << " with No. " << LC->index << "." << endl;
       } else {
-        eLog() << Verbose(0) << "ERROR: Vector " << CircleCenter << " is outside of LinkedCell's bounding box." << endl;
+        eLog() << Verbose(1) << "Vector " << CircleCenter << " is outside of LinkedCell's bounding box." << endl;
         return;
       }
@@ -2442,5 +2594,5 @@
           }
     } else {
-      eLog() << Verbose(2) << "ERROR: The projected center of the old sphere has radius " << radius << " instead of " << CircleRadius << "." << endl;
+      eLog() << Verbose(1) << "The projected center of the old sphere has radius " << radius << " instead of " << CircleRadius << "." << endl;
     }
   } else {
@@ -2533,5 +2685,5 @@
         triangles->unique();
       } else {
-        Log() << Verbose(1) << "ERROR: I cannot find a boundary point to the tessel point " << *trianglePoints[0] << "." << endl;
+        eLog() << Verbose(1) << "I cannot find a boundary point to the tessel point " << *trianglePoints[0] << "." << endl;
         return NULL;
       }
@@ -2544,5 +2696,5 @@
       for (int i=0;i<3;i++) {
         if (trianglePoints[i] == NULL) {
-          Log() << Verbose(1) << "ERROR: IsInnerPoint encounters serious error, point " << i << " not found." << endl;
+          eLog() << Verbose(1) << "IsInnerPoint encounters serious error, point " << i << " not found." << endl;
         }
         //Log() << Verbose(2) << "List of triangle points:" << endl;
@@ -2563,5 +2715,5 @@
   
   if ((triangles == NULL) || (triangles->empty())) {
-    Log() << Verbose(0) << "ERROR: There is no nearest triangle. Please check the tesselation structure.";
+    eLog() << Verbose(1) << "There is no nearest triangle. Please check the tesselation structure.";
     delete(triangles);
     return NULL;
@@ -2597,5 +2749,5 @@
       Log() << Verbose(2) << "Normal Vector of this back side is " << result->NormalVector << "." << endl;
       if (Center.ScalarProduct(&result->NormalVector) < 0) {
-        Log() << Verbose(1) << "ERROR: Front and back side yield NormalVector in wrong direction!" << endl;
+        eLog() << Verbose(1) << "Front and back side yield NormalVector in wrong direction!" << endl;
       }
     }
@@ -2699,5 +2851,5 @@
 
   if (connectedPoints->size() == 0) { // if have not found any points
-    Log() << Verbose(1) << "ERROR: We have not found any connected points to " << *Point<< "." << endl;
+    eLog() << Verbose(1) << "We have not found any connected points to " << *Point<< "." << endl;
     return NULL;
   }
@@ -2822,5 +2974,5 @@
     ReferencePoint = PointRunner->second;
   } else {
-    Log() << Verbose(2) << "ERROR: GetPathOfConnectedPoints() could not find the BoundaryPoint belonging to " << *Point << "." << endl;
+    eLog() << Verbose(1) << "GetPathOfConnectedPoints() could not find the BoundaryPoint belonging to " << *Point << "." << endl;
     return NULL;
   }
@@ -2839,5 +2991,5 @@
       LineRunner = TouchedLine.find(runner->second);
       if (LineRunner == TouchedLine.end()) {
-        Log() << Verbose(2) << "ERROR: I could not find " << *runner->second << " in the touched list." << endl;
+        eLog() << Verbose(1) << "I could not find " << *runner->second << " in the touched list." << endl;
       } else if (!LineRunner->second) {
         LineRunner->second = true;
@@ -2869,5 +3021,5 @@
                 }
               } else {
-                Log() << Verbose(2) << "ERROR: I could not find " << *triangle << " in the touched list." << endl;
+                eLog() << Verbose(1) << "I could not find " << *triangle << " in the touched list." << endl;
                 triangle = NULL;
               }
@@ -2886,5 +3038,5 @@
           LineRunner = TouchedLine.find(CurrentLine);
           if (LineRunner == TouchedLine.end())
-            Log() << Verbose(2) << "ERROR: I could not find " << *CurrentLine << " in the touched list." << endl;
+            eLog() << Verbose(1) << "I could not find " << *CurrentLine << " in the touched list." << endl;
           else
             LineRunner->second = true;
@@ -2904,5 +3056,5 @@
     }
   } else {
-    Log() << Verbose(1) << "ERROR: There are no lines attached to " << *ReferencePoint << "." << endl;
+    eLog() << Verbose(1) << "There are no lines attached to " << *ReferencePoint << "." << endl;
   }
 
